class MOdrRepRib < ApplicationRecord
  belongs_to :admin
  
  belongs_to :m_odr_rep
  
  has_one :m_odr, :through => :m_odr_rep
  
  validates :bic, :presence => true, length: { in: 8..11 }
  
  validates :iban, :presence => true
  
  validates_with IbanValidator
  
  has_many :mail_hists, :as => :element
  
  
end
