class CreateAdmins < ActiveRecord::Migration[6.0]
  def change
    create_table :admins do |t|
      t.string       :name
      t.string       :firstname
      t.string       :avatar
      t.string       :username,   :default => ""
      t.string       :email,   :default => ""
      t.string       :password_digest,   :default => ""
      t.string       :reset_password_token
      t.datetime     :reset_password_sent_at
      t.datetime     :remember_created_at
      t.integer      :sign_in_count,   :default => 0
      t.datetime     :current_sign_in_at
      t.datetime     :last_sign_in_at
      t.string       :current_sign_in_ip
      t.string       :last_sign_in_ip
      t.string       :remember_token
      
      t.integer      :p_commercial_id
      
      t.boolean      :super_admin,   :default => false

      t.timestamps
    end
  end
end
