class CreateBlockContents < ActiveRecord::Migration[6.0]
  def change
    create_table :block_contents do |t|
      t.integer      :style
      t.integer      :nbr_columns
      t.integer      :row1
      t.integer      :row2
      t.integer      :row3
      t.integer      :row4
      t.references   :image_file,   index: true
      t.integer      :margin_top
      t.integer      :margin_bottom
      t.integer      :margin_left
      t.integer      :margin_right
      t.integer      :padding_top
      t.integer      :padding_bottom
      t.integer      :padding_left
      t.integer      :padding_right
      t.boolean      :parallax,   :default => false
      t.boolean      :center,   :default => false
      t.integer      :center_width
      t.string       :background_color
      t.string       :gradient_start
      t.string       :gradient_stop

      t.timestamps
    end
  end
end
