class CreatePTruckSpaces < ActiveRecord::Migration[6.0]
  def change
    create_table :p_truck_spaces do |t|
      t.string       :name
      t.decimal      :volume,   :precision => 14,   :scale => 2
      t.references   :p_truck,   index: true
      t.integer      :default_p_tank_id
      t.string       :code

      t.timestamps
    end
  end
end
