class CreateParticulars < ActiveRecord::Migration[6.0]
  def change
    create_table :particulars do |t|
      t.boolean      :pro,   :default => false
      t.string       :organisation
      t.string       :name
      t.string       :firstname
      t.string       :address_1
      t.string       :address_2
      t.string       :address_3
      t.string       :address_4
      t.string       :address_5
      t.string       :cp
      t.string       :city
      t.string       :country
      t.string       :tel
      t.string       :email
      t.string       :tel2
      t.string       :tel3
      t.string       :fax
      t.string       :owner_type
      t.references   :owner,   index: true
      t.string       :particular_type
      t.boolean      :skip_validation,   :default => false
      t.string       :civilite
      t.boolean      :archived,   :default => false
      t.integer      :particular_ref_id
      t.boolean      :price_in_bl,   :default => true

      t.timestamps
    end
  end
end
