class MOdrProduct < ApplicationRecord
  belongs_to :m_odr_brand
  
  belongs_to :m_odr
  
  has_many :m_odr_product_remises, :dependent => :destroy
  accepts_nested_attributes_for :m_odr_product_remises, :allow_destroy => true
  
  
  def member_label 
    if self.m_odr_brand
      "#{self.m_odr_brand.name} - #{self.name}"
      
    else
      self.name
      
    end
    
  end
  
end
