class CreateMOdrs < ActiveRecord::Migration[6.0]
  def change
    create_table :m_odrs do |t|
      t.string :name
      t.string :slug
      t.date :start_at
      t.date :end_at
      t.date :public_end
      t.boolean :address_process
      t.boolean :rib_process
      t.text :description
      t.boolean :email_needed
      t.boolean :tel_needed
      t.references :p_customer, foreign_key: true
      t.integer :logo_image_file_id
      t.integer :logo_image_file_width
      
      t.integer :banner_image_file_id
      t.integer :banner_image_file_width
      
      t.integer :background_image_file_id
      t.integer :background_image_file_width
      
      
      t.text :twitter_title
      t.text :twitter_description
      t.integer :twitter_image_file_id
    
      t.text :facebook_title
      t.text :facebook_description
      t.integer :facebook_image_file_id
    
      t.integer :social_image_file_id

      t.timestamps
    end
  end
end
